﻿<?xml version="1.0" encoding="utf-8"?>
<Dsl dslVersion="1.0.0.0" Id="afce1df7-73ca-44cf-b6e0-f936bd7b44d6" Description="Description for BatRF.TagParseLanguage.TagParseLanguage" Name="TagParseLanguage" DisplayName="TagParseLanguage" Namespace="BatRF.TagParseLanguage" ProductName="BatRF" CompanyName="PHV Information Services" PackageGuid="6820c7c3-6253-466f-b44e-90a8b7edeb02" PackageNamespace="BatRF.TagParseLanguage" xmlns="http://schemas.microsoft.com/VisualStudio/2005/DslTools/DslDefinitionModel">
  <Classes>
    <DomainClass Id="d8220e6f-7e95-4c5e-af02-fa81febbbdee" Description="Description for BatRF.TagParseLanguage.TagParse" Name="TagParse" DisplayName="Tag Parse" Namespace="BatRF.TagParseLanguage">
      <ElementMergeDirectives>
        <ElementMergeDirective>
          <Index>
            <DomainClassMoniker Name="ParseMaster" />
          </Index>
          <LinkCreationPaths>
            <DomainPath>TagParseHasParseMaster.ParseMaster</DomainPath>
          </LinkCreationPaths>
        </ElementMergeDirective>
        <ElementMergeDirective>
          <Index>
            <DomainClassMoniker Name="Decoder" />
          </Index>
          <LinkCreationPaths>
            <DomainPath>TagParseHasDecoders.Decoders</DomainPath>
          </LinkCreationPaths>
        </ElementMergeDirective>
      </ElementMergeDirectives>
    </DomainClass>
    <DomainClass Id="4304bdbf-2aa7-4220-8c0b-8eb2d2f89cb1" Description="Description for BatRF.TagParseLanguage.ParseMaster" Name="ParseMaster" DisplayName="Parse Master" Namespace="BatRF.TagParseLanguage">
      <Properties>
        <DomainProperty Id="a696d56d-3f4b-496f-8278-2bd2cb6b83a6" Description="Description for BatRF.TagParseLanguage.ParseMaster.Tag Name" Name="TagName" DisplayName="Tag Name" DefaultValue="MyTag">
          <Type>
            <ExternalTypeMoniker Name="/System/String" />
          </Type>
        </DomainProperty>
        <DomainProperty Id="8d3c237a-9ecb-4136-aa96-142cea2ca26b" Description="Description for BatRF.TagParseLanguage.ParseMaster.Message Length" Name="MessageLength" DisplayName="Message Length" DefaultValue="25">
          <Type>
            <ExternalTypeMoniker Name="/System/Int32" />
          </Type>
        </DomainProperty>
      </Properties>
    </DomainClass>
    <DomainClass Id="dcc7931c-dda2-4691-91ac-425afd2d880d" Description="Description for BatRF.TagParseLanguage.Decoder" Name="Decoder" DisplayName="Decoder" Namespace="BatRF.TagParseLanguage">
      <Properties>
        <DomainProperty Id="489d8229-9f82-4889-a4c5-5562447d3439" Description="Description for BatRF.TagParseLanguage.Decoder.Start Point" Name="StartPoint" DisplayName="Start Point" DefaultValue="0">
          <Type>
            <ExternalTypeMoniker Name="/System/Int32" />
          </Type>
        </DomainProperty>
        <DomainProperty Id="8eae0f65-4355-45b4-8742-f8518558efa1" Description="Description for BatRF.TagParseLanguage.Decoder.Length" Name="Length" DisplayName="Length" DefaultValue="1">
          <Type>
            <ExternalTypeMoniker Name="/System/Int32" />
          </Type>
        </DomainProperty>
        <DomainProperty Id="c4271f5d-fa3d-4755-a2f6-565ca6dc9881" Description="Description for BatRF.TagParseLanguage.Decoder.Decode Method" Name="DecodeMethod" DisplayName="Decode Method" DefaultValue="Long4Byte">
          <Type>
            <DomainEnumerationMoniker Name="ValidDecodeMethods" />
          </Type>
        </DomainProperty>
        <DomainProperty Id="1bb5b973-d46b-458e-b29a-feab084c35fa" Description="Description for BatRF.TagParseLanguage.Decoder.Type" Name="Type" DisplayName="Type" DefaultValue="string">
          <Type>
            <ExternalTypeMoniker Name="/System/String" />
          </Type>
        </DomainProperty>
        <DomainProperty Id="754b02fd-2446-41c5-8421-bfffeb658cd5" Description="Description for BatRF.TagParseLanguage.Decoder.Decoder Name" Name="DecoderName" DisplayName="Decoder Name">
          <Type>
            <ExternalTypeMoniker Name="/System/String" />
          </Type>
        </DomainProperty>
      </Properties>
    </DomainClass>
  </Classes>
  <Relationships>
    <DomainRelationship Id="95d19ede-c415-4cea-bae9-495ea71a8c41" Description="Description for BatRF.TagParseLanguage.TagParseHasParseMaster" Name="TagParseHasParseMaster" DisplayName="Tag Parse Has Parse Master" Namespace="BatRF.TagParseLanguage" IsEmbedding="true">
      <Source>
        <DomainRole Id="fbc6e7bf-609c-45fc-a77d-880cc8ee2e37" Description="Description for BatRF.TagParseLanguage.TagParseHasParseMaster.TagParse" Name="TagParse" DisplayName="Tag Parse" PropertyName="ParseMaster" Multiplicity="One" PropertyDisplayName="Parse Master">
          <RolePlayer>
            <DomainClassMoniker Name="TagParse" />
          </RolePlayer>
        </DomainRole>
      </Source>
      <Target>
        <DomainRole Id="e55f17f3-7294-4ac2-aefe-23dd246c7be5" Description="Description for BatRF.TagParseLanguage.TagParseHasParseMaster.ParseMaster" Name="ParseMaster" DisplayName="Parse Master" PropertyName="TagParse" Multiplicity="One" PropagatesDelete="true" PropagatesCopy="true" PropertyDisplayName="Tag Parse">
          <RolePlayer>
            <DomainClassMoniker Name="ParseMaster" />
          </RolePlayer>
        </DomainRole>
      </Target>
    </DomainRelationship>
    <DomainRelationship Id="1926fcd0-9d3c-475b-9571-8f4dec9de2c4" Description="Description for BatRF.TagParseLanguage.TagParseHasDecoders" Name="TagParseHasDecoders" DisplayName="Tag Parse Has Decoders" Namespace="BatRF.TagParseLanguage" IsEmbedding="true">
      <Source>
        <DomainRole Id="ae0e90f6-3723-4aeb-83e7-ae9b55291cd3" Description="Description for BatRF.TagParseLanguage.TagParseHasDecoders.TagParse" Name="TagParse" DisplayName="Tag Parse" PropertyName="Decoders" Multiplicity="OneMany" PropertyDisplayName="Decoders">
          <RolePlayer>
            <DomainClassMoniker Name="TagParse" />
          </RolePlayer>
        </DomainRole>
      </Source>
      <Target>
        <DomainRole Id="26f8ebf0-9ade-4241-8435-5b9ae137e7b4" Description="Description for BatRF.TagParseLanguage.TagParseHasDecoders.Decoder" Name="Decoder" DisplayName="Decoder" PropertyName="TagParse" Multiplicity="One" PropagatesDelete="true" PropagatesCopy="true" PropertyDisplayName="Tag Parse">
          <RolePlayer>
            <DomainClassMoniker Name="Decoder" />
          </RolePlayer>
        </DomainRole>
      </Target>
    </DomainRelationship>
    <DomainRelationship Id="c010b5f6-7a6f-40fa-8cf2-1783bd8ac030" Description="Description for BatRF.TagParseLanguage.ParseMasterReferencesDecoders" Name="ParseMasterReferencesDecoders" DisplayName="Parse Master References Decoders" Namespace="BatRF.TagParseLanguage">
      <Source>
        <DomainRole Id="819fe7c2-5d1c-4a56-bb9b-4b1830b373ee" Description="Description for BatRF.TagParseLanguage.ParseMasterReferencesDecoders.ParseMaster" Name="ParseMaster" DisplayName="Parse Master" PropertyName="Decoders" Multiplicity="OneMany" PropertyDisplayName="Decoders">
          <RolePlayer>
            <DomainClassMoniker Name="ParseMaster" />
          </RolePlayer>
        </DomainRole>
      </Source>
      <Target>
        <DomainRole Id="92c52b8a-da71-4d41-8a67-6f35f3300615" Description="Description for BatRF.TagParseLanguage.ParseMasterReferencesDecoders.Decoder" Name="Decoder" DisplayName="Decoder" PropertyName="ParseMaster" Multiplicity="One" PropertyDisplayName="Parse Master">
          <RolePlayer>
            <DomainClassMoniker Name="Decoder" />
          </RolePlayer>
        </DomainRole>
      </Target>
    </DomainRelationship>
  </Relationships>
  <Types>
    <ExternalType Name="DateTime" Namespace="System" />
    <ExternalType Name="String" Namespace="System" />
    <ExternalType Name="Int16" Namespace="System" />
    <ExternalType Name="Int32" Namespace="System" />
    <ExternalType Name="Int64" Namespace="System" />
    <ExternalType Name="UInt16" Namespace="System" />
    <ExternalType Name="UInt32" Namespace="System" />
    <ExternalType Name="UInt64" Namespace="System" />
    <ExternalType Name="SByte" Namespace="System" />
    <ExternalType Name="Byte" Namespace="System" />
    <ExternalType Name="Double" Namespace="System" />
    <ExternalType Name="Single" Namespace="System" />
    <ExternalType Name="Guid" Namespace="System" />
    <ExternalType Name="Boolean" Namespace="System" />
    <ExternalType Name="Char" Namespace="System" />
    <DomainEnumeration Name="ValidDecodeMethods" Namespace="BatRF.TagParseLanguage" Description="Description for BatRF.TagParseLanguage.ValidDecodeMethods">
      <Literals>
        <EnumerationLiteral Description="Description for BatRF.TagParseLanguage.ValidDecodeMethods.Long4Byte" Name="Long4Byte" Value="" />
        <EnumerationLiteral Description="Description for BatRF.TagParseLanguage.ValidDecodeMethods.Boolean" Name="Boolean" Value="" />
        <EnumerationLiteral Description="Description for BatRF.TagParseLanguage.ValidDecodeMethods.TirePosition" Name="TirePosition" Value="" />
      </Literals>
    </DomainEnumeration>
  </Types>
  <Shapes>
    <GeometryShape Id="568eaf22-6648-4adb-9ef4-e4eccc27fca4" Description="Description for BatRF.TagParseLanguage.ParseManagerShape" Name="ParseManagerShape" DisplayName="Parse Manager Shape" Namespace="BatRF.TagParseLanguage" FixedTooltipText="Parse Manager Shape" FillColor="Red" InitialHeight="1" Geometry="RoundedRectangle">
      <ShapeHasDecorators Position="InnerTopLeft" HorizontalOffset="0" VerticalOffset="0">
        <TextDecorator Name="Parse Manager" DisplayName="Parse  Manager" DefaultText="Parse Manager" />
      </ShapeHasDecorators>
    </GeometryShape>
    <GeometryShape Id="c0504b9c-f46c-4ea0-92ba-6d151b65026b" Description="Description for BatRF.TagParseLanguage.DecoderShape" Name="DecoderShape" DisplayName="Decoder Shape" Namespace="BatRF.TagParseLanguage" FixedTooltipText="Decoder Shape" FillColor="Blue" InitialHeight="1" Geometry="RoundedRectangle">
      <ShapeHasDecorators Position="InnerTopLeft" HorizontalOffset="0" VerticalOffset="0">
        <TextDecorator Name="Decoder" DisplayName="Decoder" DefaultText="Decoder" />
      </ShapeHasDecorators>
    </GeometryShape>
  </Shapes>
  <Connectors>
    <Connector Id="85cba386-1020-48fc-9bde-bbc3e235c782" Description="Description for BatRF.TagParseLanguage.DecoderConnector" Name="DecoderConnector" DisplayName="Decoder Connector" Namespace="BatRF.TagParseLanguage" FixedTooltipText="Decoder Connector" TargetEndStyle="FilledArrow" />
  </Connectors>
  <XmlSerializationBehavior Name="TagParseLanguageSerializationBehavior" Namespace="BatRF.TagParseLanguage">
    <ClassData>
      <XmlClassData TypeName="TagParseLanguageDiagram" MonikerAttributeName="" MonikerElementName="minimalLanguageDiagramMoniker" ElementName="minimalLanguageDiagram" MonikerTypeName="TagParseLanguageDiagramMoniker">
        <DiagramMoniker Name="TagParseLanguageDiagram" />
      </XmlClassData>
      <XmlClassData TypeName="TagParse" MonikerAttributeName="" SerializeId="true" MonikerElementName="tagParseMoniker" ElementName="tagParse" MonikerTypeName="TagParseMoniker">
        <DomainClassMoniker Name="TagParse" />
        <ElementData>
          <XmlRelationshipData RoleElementName="parseMaster">
            <DomainRelationshipMoniker Name="TagParseHasParseMaster" />
          </XmlRelationshipData>
          <XmlRelationshipData RoleElementName="decoders">
            <DomainRelationshipMoniker Name="TagParseHasDecoders" />
          </XmlRelationshipData>
        </ElementData>
      </XmlClassData>
      <XmlClassData TypeName="ParseMaster" MonikerAttributeName="" SerializeId="true" MonikerElementName="parseMasterMoniker" ElementName="parseMaster" MonikerTypeName="ParseMasterMoniker">
        <DomainClassMoniker Name="ParseMaster" />
        <ElementData>
          <XmlPropertyData XmlName="tagName">
            <DomainPropertyMoniker Name="ParseMaster/TagName" />
          </XmlPropertyData>
          <XmlRelationshipData RoleElementName="decoders">
            <DomainRelationshipMoniker Name="ParseMasterReferencesDecoders" />
          </XmlRelationshipData>
          <XmlPropertyData XmlName="messageLength">
            <DomainPropertyMoniker Name="ParseMaster/MessageLength" />
          </XmlPropertyData>
        </ElementData>
      </XmlClassData>
      <XmlClassData TypeName="TagParseHasParseMaster" MonikerAttributeName="" MonikerElementName="tagParseHasParseMasterMoniker" ElementName="tagParseHasParseMaster" MonikerTypeName="TagParseHasParseMasterMoniker">
        <DomainRelationshipMoniker Name="TagParseHasParseMaster" />
      </XmlClassData>
      <XmlClassData TypeName="Decoder" MonikerAttributeName="" SerializeId="true" MonikerElementName="decoderMoniker" ElementName="decoder" MonikerTypeName="DecoderMoniker">
        <DomainClassMoniker Name="Decoder" />
        <ElementData>
          <XmlPropertyData XmlName="startPoint">
            <DomainPropertyMoniker Name="Decoder/StartPoint" />
          </XmlPropertyData>
          <XmlPropertyData XmlName="length">
            <DomainPropertyMoniker Name="Decoder/Length" />
          </XmlPropertyData>
          <XmlPropertyData XmlName="decodeMethod">
            <DomainPropertyMoniker Name="Decoder/DecodeMethod" />
          </XmlPropertyData>
          <XmlPropertyData XmlName="type">
            <DomainPropertyMoniker Name="Decoder/Type" />
          </XmlPropertyData>
          <XmlPropertyData XmlName="decoderName">
            <DomainPropertyMoniker Name="Decoder/DecoderName" />
          </XmlPropertyData>
        </ElementData>
      </XmlClassData>
      <XmlClassData TypeName="TagParseHasDecoders" MonikerAttributeName="" MonikerElementName="tagParseHasDecodersMoniker" ElementName="tagParseHasDecoders" MonikerTypeName="TagParseHasDecodersMoniker">
        <DomainRelationshipMoniker Name="TagParseHasDecoders" />
      </XmlClassData>
      <XmlClassData TypeName="ParseMasterReferencesDecoders" MonikerAttributeName="" MonikerElementName="parseMasterReferencesDecodersMoniker" ElementName="parseMasterReferencesDecoders" MonikerTypeName="ParseMasterReferencesDecodersMoniker">
        <DomainRelationshipMoniker Name="ParseMasterReferencesDecoders" />
      </XmlClassData>
      <XmlClassData TypeName="DecoderConnector" MonikerAttributeName="" MonikerElementName="decoderConnectorMoniker" ElementName="decoderConnector" MonikerTypeName="DecoderConnectorMoniker">
        <ConnectorMoniker Name="DecoderConnector" />
      </XmlClassData>
      <XmlClassData TypeName="ParseManagerShape" MonikerAttributeName="" MonikerElementName="parseManagerShapeMoniker" ElementName="parseManagerShape" MonikerTypeName="ParseManagerShapeMoniker">
        <GeometryShapeMoniker Name="ParseManagerShape" />
      </XmlClassData>
      <XmlClassData TypeName="DecoderShape" MonikerAttributeName="" MonikerElementName="decoderShapeMoniker" ElementName="decoderShape" MonikerTypeName="DecoderShapeMoniker">
        <GeometryShapeMoniker Name="DecoderShape" />
      </XmlClassData>
    </ClassData>
  </XmlSerializationBehavior>
  <ExplorerBehavior Name="TagParseLanguageExplorer" />
  <ConnectionBuilders>
    <ConnectionBuilder Name="ParseMasterReferencesDecodersBuilder">
      <LinkConnectDirective>
        <DomainRelationshipMoniker Name="ParseMasterReferencesDecoders" />
        <SourceDirectives>
          <RolePlayerConnectDirective>
            <AcceptingClass>
              <DomainClassMoniker Name="ParseMaster" />
            </AcceptingClass>
          </RolePlayerConnectDirective>
        </SourceDirectives>
        <TargetDirectives>
          <RolePlayerConnectDirective>
            <AcceptingClass>
              <DomainClassMoniker Name="Decoder" />
            </AcceptingClass>
          </RolePlayerConnectDirective>
        </TargetDirectives>
      </LinkConnectDirective>
    </ConnectionBuilder>
  </ConnectionBuilders>
  <Diagram Id="a349607b-22d1-4e02-a44d-5493c4c5d5e9" Description="Description for BatRF.TagParseLanguage.TagParseLanguageDiagram" Name="TagParseLanguageDiagram" DisplayName="Minimal Language Diagram" Namespace="BatRF.TagParseLanguage">
    <Class>
      <DomainClassMoniker Name="TagParse" />
    </Class>
    <ShapeMaps>
      <ShapeMap>
        <DomainClassMoniker Name="ParseMaster" />
        <ParentElementPath>
          <DomainPath>TagParseHasParseMaster.TagParse/!TagParse</DomainPath>
        </ParentElementPath>
        <GeometryShapeMoniker Name="ParseManagerShape" />
      </ShapeMap>
      <ShapeMap>
        <DomainClassMoniker Name="Decoder" />
        <ParentElementPath>
          <DomainPath>TagParseHasDecoders.TagParse/!TagParse</DomainPath>
        </ParentElementPath>
        <GeometryShapeMoniker Name="DecoderShape" />
      </ShapeMap>
    </ShapeMaps>
    <ConnectorMaps>
      <ConnectorMap>
        <ConnectorMoniker Name="DecoderConnector" />
        <DomainRelationshipMoniker Name="ParseMasterReferencesDecoders" />
      </ConnectorMap>
    </ConnectorMaps>
  </Diagram>
  <Designer FileExtension="tpl2" EditorGuid="dee20f4b-045c-420e-9e35-5331663865aa">
    <RootClass>
      <DomainClassMoniker Name="TagParse" />
    </RootClass>
    <XmlSerializationDefinition CustomPostLoad="false">
      <XmlSerializationBehaviorMoniker Name="TagParseLanguageSerializationBehavior" />
    </XmlSerializationDefinition>
    <ToolboxTab TabText="TagParseLanguage">
      <ElementTool Name="ParseMasterTool" ToolboxIcon="C:\Course\512\DSLSample\AsyncDsl\TPL Tools\Resources\UpFldrBtn.bmp" Caption="Parse Master" Tooltip="Parse Master" HelpKeyword="ParseMasterTool">
        <DomainClassMoniker Name="ParseMaster" />
      </ElementTool>
      <ElementTool Name="DecoderTool" ToolboxIcon="C:\Course\512\DSLSample\AsyncDsl\TPL Tools\Resources\NewFldrBtn.bmp" Caption="Decoder" Tooltip="Decoder" HelpKeyword="DecoderTool">
        <DomainClassMoniker Name="Decoder" />
      </ElementTool>
      <ConnectionTool Name="ParseManagerToDecoderTool" ToolboxIcon="C:\DSL\TagParser\Dsl\Resources\ConnectionTool.bmp" Caption="ParseManager To Decoder" Tooltip="Parse Manager To Decoder " HelpKeyword="ParseManagerToDecoderTool">
        <ConnectionBuilderMoniker Name="TagParseLanguage/ParseMasterReferencesDecodersBuilder" />
      </ConnectionTool>
    </ToolboxTab>
    <Validation UsesMenu="true" UsesOpen="false" UsesSave="false" UsesCustom="true" UsesLoad="false" />
    <DiagramMoniker Name="TagParseLanguageDiagram" />
  </Designer>
  <Explorer ExplorerGuid="87d171ed-abe1-4b4d-afa1-cf329d20b92e" Title="TagParseLanguage Explorer">
    <ExplorerBehaviorMoniker Name="TagParseLanguage/TagParseLanguageExplorer" />
  </Explorer>
</Dsl>